<template>
    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <h4>Update User</h4>
                </div>
                <div class="card-body">
                    <form @submit="checkForm" @submit.prevent="update">
                        <div class="row">
                            <p v-if="errors.length">
                                <b>Please correct the following error(s):</b>
                            <ul>
                                <li v-for="error in errors">{{ error }}</li>
                            </ul>
                            </p>
                            <div class="col-12 mb-2">
                                <div class="form-group">
                                    <label>Name</label>
                                    <input required type="text" class="form-control" v-model="user.name">
                                </div>
                            </div>

                            <div class="col-12">
                                <button type="submit" class="btn btn-primary">Update</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name:"update-user",
    data(){
        return {
            user:{
                name:"",
                _method:"patch"
            },
            errors:[]
        }
    },
    mounted(){
        this.showUser()
    },
    methods:{
        checkForm: function (e) {
            if (this.user.name) {
                return true;
            }

            this.errors = [];

            if (!this.user.name) {
                this.errors.push('Name required.');
            }

            e.preventDefault();
        },
        async showUser(){
            await this.axios.get(`/api/user/${this.$route.params.id}`).then(response=>{
                const { name } = response.data
                this.user.name = name
            }).catch(error=>{
                console.log(error)
            })
        },
        async update(){
            await this.axios.post(`/api/user/${this.$route.params.id}`,this.user).then(response=>{
                this.$router.push({name:"userList"})
            }).catch(error=>{
                console.log(error)
                if (error.response.status == 422){
                    this.errors = error.response.data.errors;
                }
            })
        }
    }
}
</script>
